//
// BNXBOT.CPP
// Written in C++ by Lord`Bacca`[vL] of Valhalla Legends
//
// This file contains the code to implement a bot which emnulate many of
// the functions of the BNX Chatterbox 1.03 for Windows. Please notice the
// term "emulate". That means this is not the original BNX bot source, nor
// is this intended to be an exact replica of the original program.
// 
// That being said, this bot will perform many of the default functions that
// a regular BNX 1.03 would. The responses are identical and the operation
// of the bot works much the same way. Almost all the BNX 1.03 features are
// included in the file. Please see the README.TXT file for a list of
// things not included (they can be easily added in your spare time).
//
// This code is distributed in the faith to provide a better example of what
// a fully-functional bot may do. It keeps a userlist, shitlist, offers several
// basic internal commands so that people can moderate a channel. This code
// will rejoin for ops (BNX 1.03 doesn't) in the event of a server split.
// This code will not replace the original BNX bot, nor is this a sign which
// allows you to continue to develop BNX bots and pass them off as your own.
// The original BNX bot is still under development and will have future
// versions. The original program is copyrighted - this is just an emulation.
//
// There is no guaranteed technical support provided by the author of this
// source. It is merely given out for people to modify and have a foundation
// to create bots which are richer with features. This code will definately
// give you a running start.
//
// You are a pathetic loser if you intend on updating this code and passing
// it off as your own work. However, you may incorporate this code into a
// significantly complexer bot and distribute it as your own. I do not allow
// you to modify this source and post it on another site as original work.
// If you do, give credit where it's due. (Notice, I kept the original
// creator of the GreetBot's name in the credits).
//
// Keep in mind that I'm giving away code. If you feel I have done things
// inefficiently, rewrite the function and go from there. You have that
// option. This is not my best code, because I wrote this program in 3 days.
// In the README file I'll list a whole bunch of suggested additions to
// this code (which I have programmed into my own bots), which you can
// certainly learn to add. 
//
// I have the verbal consent from a few authors of the original BNX
// to release this code. Please respect their product and continue to
// support their bot, because except for the rejoin for ops, their bot is
// superior than what this code compiles.
//
// Do not use my forum to post comments of any kind, praise or complaints,
// unless I explicitly make a BNX-source bulletin board, which I doubt I'll
// ever do. I prefer not to be contacted about any matter regarding this code.
//
// Merry Christmas, Battle.Net. May a good year of coding result.
//
// Happy Holidays,
// BeTa`PLaYeR and Lord`Bacca`[vL]
//
// Released 12/25/2000

#include "pch.h"
#pragma hdrstop


// BEGIN USER LIST FUNCTIONS

// Default Userlist Constructor - Makes an empty list
UserList::UserList() {
	head=0;
	tail=&head;
	elements=0;
}

// Add a user into the list by defining all the attributes.
void UserList::AddUser(char *szUser, char *szPass, int Access, bool holdsOps,bool loggedIn) {
	User *newUser;
	newUser = new User;
	strcpy(newUser->Name,szUser);
	strcpy(newUser->Password,szPass);
	newUser->Access=Access;
	newUser->holdsOps=holdsOps;
	newUser->loggedIn=loggedIn;
	newUser->speak=true;
	newUser->expireTime=0;

	*tail = newUser;
	newUser->next = 0;
	tail = &newUser->next;
	elements++;
}

// Add a user into the list by passing a reference to a user object.
void UserList::AddUser(User &addedUser) {
	User *newUser;
	newUser = new User;
	strcpy(newUser->Name,addedUser.Name);
	strcpy(newUser->Password,addedUser.Password);
	newUser->Access=addedUser.Access;
	newUser->holdsOps=addedUser.holdsOps;
	newUser->loggedIn=addedUser.loggedIn;
	newUser->speak=addedUser.speak;
	newUser->expireTime=addedUser.expireTime;

	*tail = newUser;
	newUser->next = 0;
	tail = &newUser->next;
	elements++;
}

// Remove a user by name from the user list object.
void UserList::RemoveUser(char *szName) {
	User *pPrev = head;
    User *pHead = head;
	while (pHead) {
		if (stricmp(pHead->Name,szName) == 0) {
			if (pHead == head) {
				head = pHead->next;
				delete pHead;
				if(!head)
				 tail = &head;
				elements--;
				return;
			}
			else {
				User *pTmp = pHead;
				pHead=pHead->next;
				delete pTmp;
				pPrev->next = pHead;
				if (!pHead)
					tail = &pPrev->next;
				elements--;
				return;
			}
		}
		pPrev=pHead;
		pHead = pHead->next;
	}
}

// Find the index number of a user's name. Returns
// -1 if not found.
int UserList::FindUserIndex(char *szName) {
	int index=0;
	User *pHead = head;
	while (pHead) {
		if (stricmp(pHead->Name,szName)==0) {
			return index;
		}
		pHead = pHead->next;
		index++;
	}
	return -1;
}


// Retrieves a user's profile by name and puts its information
// into a User object
bool UserList::FindUser(char *szName, User &rUser) {
	User *pHead = head;
	while (pHead) {
		if (stricmp(pHead->Name,szName)==0) {
			strcpy(rUser.Name,pHead->Name);
			strcpy(rUser.Password,pHead->Password);
			rUser.Access=pHead->Access;
			rUser.holdsOps=pHead->holdsOps;
			rUser.loggedIn=pHead->loggedIn;
			rUser.speak=pHead->speak;
			rUser.expireTime=pHead->expireTime;
			return true;
		}
		pHead = pHead->next;
	}
	return false;
}


// Retrieves a user's profile by index number and puts its
// information into a User object. 
bool UserList::GetUser(int index, User &rUser) {
	int tmpIdx = 0;
	if (index < 0)
		return false;

	User *pHead = head;
	while (pHead) {
		if (tmpIdx==index) {
			strcpy(rUser.Name,pHead->Name);
			strcpy(rUser.Password,pHead->Password);
			rUser.Access=pHead->Access;
			rUser.holdsOps=pHead->holdsOps;
			rUser.loggedIn=pHead->loggedIn;
			rUser.speak=pHead->speak;
			rUser.expireTime=pHead->expireTime;
			return true;
		}
		pHead = pHead->next;
		tmpIdx++;
	}
	return false;
}

// Updates a user's entry within the user list. If the
// user name isn't present, it will add the entry into the
// list.
bool UserList::ModifyUser(char *szName, User &szInfo) {
	int tmpIdx = FindUserIndex(szName);
	if (tmpIdx < 0) {
		AddUser(szInfo);
		return true;
	}

	int index=0;
	User *pHead = head;
	while (pHead) {
		if (index==tmpIdx) {
			strcpy(pHead->Name, szInfo.Name);
			strcpy(pHead->Password,szInfo.Password);
			pHead->Access=szInfo.Access;
			pHead->holdsOps=szInfo.holdsOps;
			pHead->loggedIn=szInfo.loggedIn;
			pHead->speak=szInfo.speak;
			pHead->expireTime=szInfo.expireTime;
			return true;
		}
		pHead = pHead->next;
		index++;
	}
	return false;
}

// Returns the number of entires within the user list object.
int UserList::GetElements() {
	return elements;
}

// Removes all entries in the user list object
// (You want to do this on occasion to free memory, like when
// the bot is shut down)
void UserList::FlushList() {
	while (head) {
		User *p = head;
		head = head->next;
		delete p;
	}
	elements=0;
	tail = &head;
}


/*****************************************************************************
*
* Virtual Event Handlers
*
******/

//=============================================================================
int BNXBot::OnChannel(char *szSpeaker, u_long uFlags, char *szEventText) {

  BnBot::OnChannel(szSpeaker, uFlags, szEventText);
  strcpy(botChannel,szEventText);
  chanList.FlushList();

  // If it's not in the home channel, join it.
  if (stricmp(botChannel,szHomeChannel) != 0) {
	  Send("/join %s\r\n",szHomeChannel);
	  return 1;
  }

  return 1;
}

//============================================================================
int BNXBot::OnJoin(char *szSpeaker, u_long uFlags, char *szEventText) {

  BnBot::OnJoin(szSpeaker, uFlags, szEventText);

  User tmpUser;
  if (!userDB.FindUser(szSpeaker,tmpUser))	// Try to get the user's database
	  CreateDefaultUser(szSpeaker,tmpUser);	// entry.

  if (uFlags % 16 == 2)
    tmpUser.holdsOps = true;

  chanList.AddUser(tmpUser);				// Add the user into the channel
											// list.

  // Check to see if the user is shitlisted.
  if (holdsOps) {
	  User tmpUser;
	  for (int i = 0; i < shitList.GetElements(); i++) {
		  shitList.GetUser(i,tmpUser);
		  if (MatchUser(szSpeaker,tmpUser.Name) == 0)
			  Send("/ban %s because I don't like you\r\n",szSpeaker);
	  }
  }

  return 1;
}

//============================================================================
int BNXBot::OnShowUser(char *szSpeaker, u_long uFlags, char *szEventText) {

  BnBot::OnShowUser(szSpeaker, uFlags, szEventText);

  User tmpUser;
  if (!userDB.FindUser(szSpeaker,tmpUser))	// Try to get the user's database
	  CreateDefaultUser(szSpeaker,tmpUser);	// entry.

  if (uFlags % 16 == 2)
    tmpUser.holdsOps = true;

  chanList.AddUser(tmpUser);				// Add the user into the channel
											// list.

  // Check to see if the user is shitlisted.
  if (holdsOps) {
	  User tmpUser;
	  for (int i = 0; i < shitList.GetElements(); i++) {
		  shitList.GetUser(i,tmpUser);
		  if (MatchUser(szSpeaker,tmpUser.Name) == 0)
			  Send("/ban %s because I don't like you\r\n",szSpeaker);
	  }
  }

  return 1;
}

//============================================================================
int BNXBot::OnLeave(char *szSpeaker, u_long uFlags, char *szEventText) {

  BnBot::OnLeave(szSpeaker, uFlags, szEventText);

  chanList.RemoveUser(szSpeaker);	  // Remove the user from the channel list

  if (!holdsOps && nUsers <= 1) {     // Rejoin for ops procedure.
	  BnBot::queueRejoinForOps;
	  BnBot::rejoinForOpsExpire = GetTickCount() + 500;
  }

  return 1;
}
//============================================================================
int BNXBot::OnTalk(char *szSpeaker, u_long uFlags, char *szEventText) {

  BnBot::OnTalk(szSpeaker, uFlags, szEventText);

  // Handle chatterbox functions
  char eventUpper[MAXTEXTLENGTH];
  char uniqueNameUpper[MAXTEXTLENGTH];
  strcpy(eventUpper,szEventText);
  _strupr(eventUpper);
  strcpy(uniqueNameUpper,szUniqueName);
  _strupr(uniqueNameUpper);


  // Part of the voteban code, this will tally the votes if a voteban
  // is in progress.
  if (voteBanMode && stricmp(szEventText,"yea") == 0) {
	  BnBot::nVotes++;
	  BnBot::nVotesTotal++;
  }
  else if (voteBanMode && stricmp(szEventText,"yea") == 0)
	  BnBot::nVotesTotal++;

  // If the person says the bot's name in a message, issue a random
  // response.
  if (strstr(eventUpper,uniqueNameUpper)) {
	  RandomResponse(szSpeaker,SPOKEN);
  }

  return 1;
}
//============================================================================
int BNXBot::OnWhisper(char *szSpeaker, u_long uFlags, char *szEventText) {

  BnBot::OnWhisper(szSpeaker, uFlags, szEventText);
  char commandName[MAXTEXTLENGTH];
  char commandArguments[MAXTEXTLENGTH];

  // Break the whisper message into a command name and an arguments list.
  ParseCommand(commandName,commandArguments,szEventText);

  if (stricmp(commandName,"login") == 0) {	  // Check to see if they 
	  UserLogin(szSpeaker, commandArguments); // are logging in
	  return 1;
  }

  if (stricmp(commandName,"logout") == 0) {	// Check to see if they 
	  UserLogout(szSpeaker);				// are logging out
	  return 1;
  }

  if (stricmp(commandName,"shutup") == 0) {	// If they say shut up, 
	  CmdShutup(szSpeaker);					// turn off responses.
	  return 1;
  }


  bool executeCommand = false;				// Try executing the command
  User tmpData;								// if logged in and update
  DWORD currentTick = GetTickCount();		// expire time...
  if (loggedInList.FindUser(szSpeaker,tmpData)) {
	  if (tmpData.loggedIn) {
		  if (currentTick < tmpData.expireTime) {
			executeCommand=true;
			tmpData.expireTime = currentTick + 5 * 60 * 1000;
			loggedInList.ModifyUser(szSpeaker,tmpData);
		  }
		  else {
			  tmpData.loggedIn = false;
			  loggedInList.ModifyUser(szSpeaker,tmpData);
		  }
	  }
  }
  

  if (executeCommand)
	  ExecuteCommand(commandName,commandArguments,szSpeaker);
  else										// Otherwise send a random
	  RandomResponse(szSpeaker,WHISPERED);	// BNX response


  return 1;
}

// Function that executes when the bot disconnects - used to free up memory
// and close the connection. (Note, the userDB is not flushed here because
// perhaps Battle.net cloesd the connection, and you want to attempt to 
// reconnect.)
void BNXBot::Disconnect() {
	chanList.FlushList();
	loggedInList.FlushList();
	BnBot::Disconnect();
}

//============================================================================
// END EVENT HANDLERS

void BNXBot::ParseCommand(char *szCommandName, char *szArguments, const char *szEventText) {

	// Parses the event text into a command name (one word) and the
	// argument list.
	//
	// Returns a NULL string if there aren't any arguments.

	char szTmpEventText[MAXTEXTLENGTH];
	char szTmpArguments[MAXTEXTLENGTH];
	strcpy(szTmpEventText,szEventText);

	strcpy(szCommandName,"");
	strcpy(szArguments,"");

	if ((strlen(szEventText) == 0) || szEventText[0] == ' ')
		return;

	strcpy(szCommandName,strtok(szTmpEventText," "));

	bool trap=false;
	bool leadingspaces=true;
	strcpy(szTmpArguments,"");
	int strpos=0;

	for (int i = 0; i < strlen(szEventText); i++) {
		if (!trap) {
			if (szEventText[i] == ' ')
				trap=true;
		}
		else {		// What the heck, filter out multiple spaces, could
					// cause problems later

			if (!leadingspaces || szEventText[i] != ' ') {
				leadingspaces=false;
				szTmpArguments[strpos++] = szEventText[i];
				if (szEventText[i] == ' ')
					leadingspaces=true;
			}
		}
	}
	szTmpArguments[strpos] = '\0';
	strcpy(szArguments,szTmpArguments);		
}

bool BNXBot::ParseDBEntry(char *szBuffer, User &rBuffer) {

	// Parses a database entry string and stores the username, 
	// access level and password into a User object.

	char tmpEntry[2056];
	int tmpctr = 0, varctr=0;
	strcpy(tmpEntry,"");
	CreateDefaultUser(rBuffer); // Make a blank user entry just so the
								// function doesn't return complete
								// garbage in case the function
								// doesn't find a complete DB entry.

	if (strlen(szBuffer) == 0 || szBuffer[0] == ';')
		return false;

	for (int i = 0; i <= strlen(szBuffer); i++) {
		if ((szBuffer[i] != ' ') && (szBuffer[i] != '\0')) {
			tmpEntry[tmpctr++] = szBuffer[i];
		}
		else {
			int tmpAccess;
			tmpEntry[tmpctr] = '\0';
			switch(varctr) {
			case 0:
				strcpy(rBuffer.Name,tmpEntry);
				tmpctr=0;
				varctr++;
				break;

			case 1:
				tmpAccess = atoi(tmpEntry);
				rBuffer.Access = tmpAccess;
				tmpctr=0;
				varctr++;
				break;

			case 2:
				strcpy(rBuffer.Password,tmpEntry);
				tmpctr=0;
				varctr++;
			    return true;	// Done parsing access list entry.
			}
		}
	}
	if (varctr == 2)			// Let this work for the shitlist
		return true;			// file too.

	return false;	// It wasn't a complete database line. Return false.
}

void BNXBot::WriteFileHeader(char *szText, ofstream &fileHandle) {

	// Writes a one-line file header. (You can make multiple if you
	// get creative with \n characters. fileHandle should be an
	// open file.

	fileHandle << ";" << endl;
	fileHandle << "; " << szText << endl;
	fileHandle << ";" << endl;
}


void BNXBot::UserLogin(char *szName, char *szPass) {

	// Handles user login requests. Makes the person as 
	// "logged in" in the loggedIn list, and initially givesperson
	// the user 5 minutes of idle time to issue commands.

	User tmpData;
	User dbData;

	if (!loggedInList.FindUser(szName,tmpData))	// Hard to explain, but 
		if (!chanList.FindUser(szName,tmpData))	// I'm trying to get an 
			CreateDefaultUser(szName,tmpData);	// active user handle here,
												// and if I don't, make one.
	
	if (userDB.FindUser(szName,dbData)) {		// Get the user's password
		if (stricmp(szPass,dbData.Password) == 0) {	// Compare passwords

			strcpy(tmpData.Password,szPass);		// Log the user in
			tmpData.loggedIn=true;
			tmpData.expireTime=GetTickCount() + 5 * 60 * 1000;
			loggedInList.ModifyUser(szName,tmpData);

			Send("/w %s Your wish is my command, master.\r\n",szName);
			return;
		}
	}
	RandomResponse(szName,WHISPERED);	// Else, act stupid :)
}

void BNXBot::UserLogout(char *szName) {

	// Marks the user as logged out by modifying the loggedIn 
	// attribute

	User tmpData;
	if (loggedInList.FindUser(szName,tmpData)) {
		tmpData.loggedIn=false;
		loggedInList.ModifyUser(szName,tmpData);
	}
	Send("/w %s Fare the well...\r\n",szName);
}

void BNXBot::LoadDatabase(int type) {

	/* Load a user database
	   When Type ==
			        ACCESSLIST, load the access list
					SHITLIST, load the shit list
	*/

	UserList* db;
	char file[MAXTEXTLENGTH];

	if (type == ACCESSLIST) {	// Point the function to the right
		db=&userDB;				// database.
		strcpy(file,BnBot::szUserFile);
	}
	else if (type == SHITLIST) {
		db=&shitList;
		strcpy(file,BnBot::szShitFile);
	}

	char *buffer = new char[2056];
	char *primary = new char[16];
	char *password = new char[255];
	strcpy(buffer,"");
	strcpy(primary,"");
	int loaded = 0;

	ifstream database;

	database.open(file,ios::in);	// Open the database file
	
	User tmpUser;
	while (!database.eof()) {		// Read the database
		database.getline(buffer,2056);
		if (strlen(buffer) > 0) {
			if (ParseDBEntry(buffer,tmpUser)) {
  		       db->AddUser(tmpUser);
			   loaded++;
			}
			sprintf(buffer,"");
		}
	}
	database.close();				// Close the database file

	delete[] buffer;				// Delete dynamically allocated
	delete[] primary;				// memory.
	delete[] password;
}

void BNXBot::WriteDatabase(UserList &database, char *szFile, int type) {

	// Write a user/shitlist database
	ofstream db;
	db.open(szFile,ios::out);
	
	if (type == ACCESSLIST)
		WriteFileHeader("access.lst - User access list.",db);
	else if (type == SHITLIST)
		WriteFileHeader("shit.lst - User access list",db);

	char tmpData[MAXTEXTLENGTH];
	User tmpUser;

	for (int i = 0; i < database.GetElements(); i++) {
		database.GetUser(i,tmpUser);
		if (type == ACCESSLIST)
			sprintf(tmpData,"%s %d %s",tmpUser.Name,tmpUser.Access,tmpUser.Password);
		else if (type == SHITLIST)
			sprintf(tmpData,"%s 0",tmpUser.Name);
		else
			break;

		db << tmpData << endl;
	}
	db.close();
}

void BNXBot::CreateDefaultUser(User &rUser) {

	// Default values for a blank user. This helps to ensure that the
	// bot doesn't handle randomly-created garbage sometimes.
	strcpy(rUser.Name,"");
	strcpy(rUser.Password,"");
	rUser.Access=0;
	rUser.holdsOps=false;
	rUser.speak=true;
	rUser.loggedIn=false;
	rUser.expireTime=0;
}

void BNXBot::CreateDefaultUser(char *szName, User &rUser) {

	// Create a blank user, only this time we know the user's name.
	// (Useful for when somebody just joined the channel, and there's
	// no database entry for him/her)

	CreateDefaultUser(rUser);
	strcpy(rUser.Name,szName);
}

int BNXBot::MatchUser(char *szUser, char *szDBEntry) {
	
	// Attempt to compare a user against a database entry, allowing for 
	// wildcards. It will return 0 if there is a match, otherwise a non-zero
	// value if there is not.

	char tmpUser[16], tmpDBEntry[MAXTEXTLENGTH];
	strcpy(tmpUser,szUser);
	strcpy(tmpDBEntry,szDBEntry);
	_strupr(tmpUser);

	if (strstr(szDBEntry,"*")) {
		RemoveWildcards(szDBEntry);
		_strupr(tmpDBEntry);
		if (strstr(tmpUser,tmpDBEntry))
			return 0;
		else
			return -1;
	}
	else
		return stricmp(szUser,szDBEntry);
}

void BNXBot::RemoveWildcards(char *szString) {

	// Removes wildcards out of a string.
	int i, counter = 0;
	char tmpStr[MAXTEXTLENGTH];
	strcpy(tmpStr,"");

	for (i = 0; i < strlen(szString); i++)
		if (szString[i] != '*')
			tmpStr[counter++] = szString[i];

	tmpStr[counter] = '\0';

	strcpy(szString,tmpStr);
}

void BNXBot::ExecuteCommand(char *szCommand, char *szArguments, char *szSpeaker) {
	
	// Execute the appropriate function for the given command.
	// The person must be logged in before one of their commands reaches this point
	// (That is why the login and shutup functions are located in the OnWhisper function
	// instead).
	
	if (stricmp(szCommand,"ban") == 0) {
		CmdBan(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"chatter") == 0) {
		CmdChatter(szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"designate") == 0) {
		CmdDesignate(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"ignore") == 0) {
		CmdIgnore(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"join") == 0) {
		CmdJoin(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"kick") == 0) {
		CmdKick(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"say") == 0) {
		CmdSay(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"shitadd") == 0) {
		CmdShitadd(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"shitdel") == 0) {
		CmdShitdel(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"shitlist") == 0) {
		CmdShitlist(szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"splatterkick") == 0) {
		CmdSplatterKick(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"squelch") == 0) {
		CmdIgnore(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"shutdown") == 0) {
		CmdShutdown(szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"unban") == 0) {
		CmdUnban(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"unsquelch") == 0) {
		CmdUnsquelch(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"useradd") == 0) {
		CmdUseradd(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"userdel") == 0) {
		CmdUserdel(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"userlist") == 0) {
		CmdUserlist(szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"voteban") == 0) {
		CmdVoteban(szArguments,szSpeaker);
		return;
	}
	else if (stricmp(szCommand,"where") == 0) {
		CmdWhere(szSpeaker);
		return;
	}
	else				// Command not found.
		RandomResponse(szSpeaker,WHISPERED);
}

void BNXBot::RandomResponse(char *szName, int type) {

	// Those ever-so-popular responses for which BNX is famous.
	// Why's this function so long? If the user issued the "shutup"
	//    command, the bot doesn't whisper anything back

	User tmpUser;								// Get User Attributes
	if (!loggedInList.FindUser(szName,tmpUser))	
		if (!chanList.FindUser(szName,tmpUser))
			CreateDefaultUser(szName,tmpUser);

	if (!tmpUser.speak)		// If the user has issued the shutup
		return;				// command, don't say anything

	char whispermask[30];	// Otherwise, continue...
	
	if (type == WHISPERED)	// Build the right kind of message if
		sprintf(whispermask,"/w %s",szName); // it should be spoken
	else if (type == SPOKEN)				 // or whispered.
		sprintf(whispermask,"%s:",szName);

	srand(GetTickCount());
	int randnum = rand() % 5;

	switch (randnum) {
	case 0:
		Send("%s Get outta town!\r\n", whispermask);
		break;
	case 1:
		Send("%s You must be joking!\r\n", whispermask);
		break;
	case 2:
		Send("%s You're kidding!\r\n", whispermask);
		break;
	case 3:
		Send("%s Please go on.\r\n", whispermask);
		break;
	case 4:
		Send("%s Are you talkin' to me?\r\n", whispermask);
	}
}

void BNXBot::CmdBan(char *szArguments, char *szSpeaker) {

	// Ban a user. Requires access level 60.
	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access >= 60) {	// Check access level
		if (holdsOps) {				// Check to see if the bot has ops
			Send("/ban %s\r\n", szArguments);
			Send("/w %s He is forever banned!\r\n",szSpeaker);
		}
		else						// ERROR: Doesn't have ops
			Send("/w %s I don't have OP!\r\n",szSpeaker);
	}
	else							// ERROR: Insufficient access level
		RandomResponse(szSpeaker,WHISPERED);
}

void BNXBot::CmdChatter(char *szSpeaker) {

	// In all honesty, I have no idea what the hell this function's
	// for. It says chattering is on, but you cannot turn it off ;)
	//
	// Oh well, here's the function anyways, as if it did something!

	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access == 100) {
		chatter=true;
		Send("/w %s Permission to speak freely, sir?\r\n",szSpeaker);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);
}


void BNXBot::CmdDesignate(char *szArguments, char *szSpeaker) {

	// Designate a user (see the ban code for the description of the
	// extra code) - Requires 100 access.

	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access == 100) {
		if (holdsOps) {
		  char tmpPerson[MAXTEXTLENGTH];
		  if (strlen(szArguments) == 0)
			  return;	

		  strcpy(tmpPerson,strtok(szArguments," "));
	
		  Send("/designate %s\r\n",tmpPerson);
		  Send("/w %s OK, designated.\r\n",szSpeaker);
		}
		else
			Send("/w %s I don't have OP!\r\n",szSpeaker);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);
}

void BNXBot::CmdIgnore(char *szArguments, char *szSpeaker) {

	// Squelches a user. Requires 100 access.
	char tmpPerson[MAXTEXTLENGTH];
	if (strlen(szArguments) == 0)
		  return;
	
	strcpy(tmpPerson,strtok(szArguments," "));

	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access == 100) {
		Send("/ignore %s\r\n",tmpPerson);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);
}

void BNXBot::CmdJoin(char *szChan, char *szSpeaker) {

	// Tells the bot to join another channel. 
	// Requires 100 access.

	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access == 100) {
		SetHomeChannel(szChan);
		Send("/join %s\r\n",szChan);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);
}

void BNXBot::CmdKick(char *szArguments, char *szSpeaker) {

	// Kicks a user out of the channel, if holding ops.
	// Requires 60 access.

	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access >= 60) {
		if (holdsOps)
			Send("/kick %s\r\n",szArguments);
		else
			Send("/w %s I don't have OP!\r\n",szSpeaker);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);
}

void BNXBot::CmdSay(char *szText, char *szSpeaker) {

	// Makes the bot say something.
	// Requires 100 acess.

	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access == 100) {
		Send("%s\r\n",szText);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);
}

void BNXBot::CmdShitadd(char *szArguments, char *szSpeaker) {

	// Shitlists a user.
	// Requires 100 access.

	User tmpUser;
	User dbSpeaker;
	CreateDefaultUser(tmpUser);

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access == 100) {
		if (strlen(szArguments) == 0) {
			RandomResponse(szSpeaker,WHISPERED);
			return;
		}

	  strcpy(tmpUser.Name,strtok(szArguments," "));
	  tmpUser.Access=0;
	  
	  shitList.AddUser(tmpUser);
	  WriteDatabase(shitList,szShitFile,SHITLIST);
	  if (holdsOps)
		  Send("/ban %s because I don't like you\r\n",tmpUser.Name);
	  Send("/w %s %s shitlisted.\r\n",szSpeaker,tmpUser.Name);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);

}

void BNXBot::CmdShitdel(char *szArguments, char *szSpeaker) {

	// Removes a person from the shitlist.
	// Requires 100 access.

	User tmpUser;
	User dbSpeaker;
	char tmpPerson[MAXTEXTLENGTH];
	strcpy(tmpPerson,"");

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access == 100) {
		if (strlen(szArguments) > 0) {
			strcpy(tmpPerson,strtok(szArguments," "));
			if (shitList.FindUser(tmpPerson,tmpUser)) {
				shitList.RemoveUser(tmpPerson);
				WriteDatabase(shitList,szShitFile,SHITLIST);
				Send("/w %s Deleted %s\r\n",szSpeaker,tmpPerson);
				return;
			}
		}

	}
	// User was not found in the shitlist.
	Send("/w %s Cannot delete %s\r\n",szSpeaker,tmpPerson);
}

void BNXBot::CmdShitlist(char *szSpeaker) {

	// Displays the contents of the shitlist file from memory.
	// Requires 100 access.
	
	User tmpUser;
	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access == 100) {
		Send("/w %s Shit List:\r\n",szSpeaker);
		for (int i = 0; i < shitList.GetElements(); i++) {
			shitList.GetUser(i,tmpUser);
			Send("/w %s %s %d\r\n",szSpeaker,tmpUser.Name,tmpUser.Access);
		}
		Send("/w %s End of Shit List.\r\n",szSpeaker);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);
}

void BNXBot::CmdShutdown(char *szSpeaker) {

	// Shuts the bot down. You might learn why it's a good idea to make sure
	// you issue a shutdown command by reading the comments in this function.
	//
	// Remember, if you do not destroy dynamically allocated memory, it will
	// be unavailable to be used by Windows until you reboot, resulting in
	// a draining of memory/resources.
	//
	// Requires 100 access.

	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access == 100) {
		char message[MAXTEXTLENGTH];
		sprintf(message,"/w %s Sir, if you don't mind, I'll close down for a while...\r\n",szSpeaker);
		send(s,message,strlen(message),0);
		shutdown=true;	// Mark the bot as shut down, so it doesn't reconnect.

		userDB.FlushList();    // Free up database memory.
		shitList.FlushList();
		Disconnect();	// Disconnects and frees up channel list memory.
	}	
	else
		RandomResponse(szSpeaker,WHISPERED);
}

void BNXBot::CmdShutup(char *szSpeaker) {

	// Notifies the bot that it should not issue chattered responses
	// to that user.
	//
	// Anyone may execute this command.

	User tmpUser;
	if (!loggedInList.FindUser(szSpeaker,tmpUser))
		if (!chanList.FindUser(szSpeaker,tmpUser)) 
			CreateDefaultUser(szSpeaker,tmpUser);

	tmpUser.speak=false;
	loggedInList.ModifyUser(szSpeaker,tmpUser);

	Send("/w %s OK, I won't talk to you anymore.\r\n",szSpeaker);
}


void BNXBot::CmdSplatterKick(char *szArguments, char *szSpeaker) {

	// Handles splatter-kicking, one of the great features about
	// BNX bots.
	//
	// Requires 60 access.

	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access >= 60) {
		if (holdsOps) {
	        char tmpPerson[MAXTEXTLENGTH];
		    if (strlen(szArguments) == 0)
			  return;

			strcpy(tmpPerson,strtok(szArguments," "));

			BnBot::RandomBanMessage(tmpPerson); // Function containing the
												// procedure to splatter a user.
		
			Send("/w %s Consider him splattered.\r\n",szSpeaker);
		}
		else
			Send("/w %s I don't have OP!\r\n",szSpeaker);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);

}

void BNXBot::CmdUnban(char *szArguments, char *szSpeaker) {

	// Unban a user
	// Requires 60 access.

	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access >= 60) {
		if (holdsOps) {
			char tmpPerson[MAXTEXTLENGTH];
		  if (strlen(szArguments) == 0)
			  return;	

		  strcpy(tmpPerson,strtok(szArguments," "));

		  Send("/unban %s\r\n",tmpPerson);
		  Send("/w %s Aw, do I have to let him back in?\r\n",szSpeaker);
		}
		else
			Send("/w %s I don't have OP!\r\n",szSpeaker);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);
}

void BNXBot::CmdUnsquelch(char *szArguments, char *szSpeaker) {

	// Unsquelch a user.
	// Requires 100 access.

	char tmpPerson[MAXTEXTLENGTH];
	if (strlen(szArguments) == 0)
		  return;
	
	strcpy(tmpPerson,strtok(szArguments," "));
	
	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access == 100) {
		Send("/unsquelch %s\r\n",tmpPerson);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);
}

void BNXBot::CmdUseradd(char *szArguments, char *szSpeaker) {

	// Add a user to the bot's database. (This does not handle
	// shitlisting).
	//
	// Requires 100 access.

	User tmpUser;
	User dbUser;
	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access == 100) {
	  strcat(szArguments," ");
	  ParseDBEntry(szArguments,tmpUser);
	
	  userDB.ModifyUser(tmpUser.Name,tmpUser);

	  WriteDatabase(userDB,szUserFile,ACCESSLIST);
	  Send("/w %s Added %s, level %d, pass %s\r\n",szSpeaker,tmpUser.Name,tmpUser.Access,tmpUser.Password);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);

}

void BNXBot::CmdUserdel(char *szArguments, char *szSpeaker) {

	// Remove a user from the bot's database.
	// Requires 100 access.

	User tmpUser;
	User dbSpeaker;
	char tmpPerson[MAXTEXTLENGTH];
	strcpy(tmpPerson,"");

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access == 100) {
		if (strlen(szArguments) > 0) {
			strcpy(tmpPerson,strtok(szArguments," "));
			if (userDB.FindUser(tmpPerson,tmpUser)) {
				userDB.RemoveUser(tmpPerson);
				WriteDatabase(userDB,szShitFile,ACCESSLIST);
				Send("/w %s Deleted %s\r\n",szSpeaker,tmpPerson);
				return;
			}
		}

	}

	// Entry not found.
	Send("/w %s Cannot delete %s\r\n",szSpeaker,tmpPerson);
}


void BNXBot::CmdUserlist(char *szSpeaker) {

	// Lists the contents of the user database from memory.
	// Requires 100 access.
	
	User tmpUser;
	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access == 100) {
		Send("/w %s Access List:\r\n",szSpeaker);
		for (int i = 0; i < userDB.GetElements(); i++) {
			userDB.GetUser(i,tmpUser);
			Send("/w %s %s %d\r\n",szSpeaker,tmpUser.Name,tmpUser.Access);
		}
		Send("/w %s End of Access List.\r\n",szSpeaker);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);
}

void BNXBot::CmdVoteban(char *szArguments, char *szSpeaker) {

	// Begins the process to allow the current channel to vote if
	// a person should be banned out of a channel the bot is holding
	// ops.
	//
	// Requires 60 access.

	User tmpUser;
	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access >= 60) {
		if (!holdsOps) {
			Send("/w %s I don't have OP!\r\n",szSpeaker);
			return;
		}

		if (voteBanMode)  // If a vote is in process, ignore the request.
			return;

		char tmpPerson[MAXTEXTLENGTH];
		if (strlen(szArguments) == 0)
			  return;
	
		strcpy(tmpPerson,strtok(szArguments," "));
		if (!chanList.FindUser(tmpPerson,tmpUser)) {
			Send("/w %s %s is not here for me to ban!\r\n",szSpeaker,tmpPerson);
			return;
		}
	
		Send("If you want me to ban %s, say \"Yea\" - if not, say \"Nay\"\r\n",tmpPerson);
		Send("I will tally the votes in 30 seconds.\r\n");

		// Set the bot up to tally the votes. Give the channel 30 seconds to cast their
		// votes.

		BnBot::voteBanMode = true;
		BnBot::voteBanExpire = GetTickCount() + 30 * 1000;
		BnBot::nVotes = 0;
		BnBot::nVotesTotal = 0;
		strcpy(BnBot::szVoteBanUser,tmpPerson);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);
}


void BNXBot::CmdWhere(char *szSpeaker) {

	// Whispers back where the bot is located.
	// Requires 100 access. 

	User dbSpeaker;

	userDB.FindUser(szSpeaker,dbSpeaker);

	if (dbSpeaker.Access == 100) {
		Send("/w %s I am in channel %s.\r\n",szSpeaker,szCurrentChannel);
	}
	else
		RandomResponse(szSpeaker,WHISPERED);
}