//
// BNXBOT.H
//
// Emulated BNX Chatterbox 1.03
// Please see the comments in BNXBOT.CPP about the scope and usage of
// this bot.
//
// by Lord`Bacca`[vL] 12/25/2000
//
//

#ifndef _BNXBOT_H_
#define _BNXBOT_H_

#include "bnbot.h"

#define WHISPERED	0
#define SPOKEN		1

#define ACCESSLIST  0
#define SHITLIST    1

struct User {
	char Name[16];
	char Password[255];
	int Access;
	bool loggedIn;
	bool holdsOps;
	bool speak;
	DWORD expireTime;
	User *next;
};

class UserList {
	User *head, **tail;
	int elements;
public:
	UserList();
	~UserList() { FlushList(); }

	void AddUser(char *szUser, char *szPass, int Access, bool holdsOps, bool loggedIn);
	void AddUser(User &addedUser);
    void RemoveUser(char *szName);
	void FlushList();
	bool FindUser(char *szName, User &rUser);
	int FindUserIndex(char *szName);
	bool GetUser(int index, User &rUser);
	bool ModifyUser(char *szName, User &szInfo);
	int GetElements();
};


class BNXBot : public BnBot {
public:
  BNXBot() { chatter = true; };
  ~BNXBot() { shitList.FlushList(); userDB.FlushList();
		      chanList.FlushList(); loggedInList.FlushList(); };

  // Battle.net Event Handlers
  int OnJoin(char *szSpeaker, u_long uFlags, char *szEventText);
  int OnShowUser(char *szSpeaker, u_long uFlags, char *szEventText);
  int OnChannel(char *szSpeaker, u_long uFlags, char *szEventText);
  int OnLeave(char *szSpeaker, u_long uFlags, char *szEventText);
  int OnTalk(char *szSpeaker, u_long uFlags, char *szEventText);
  int OnWhisper(char *szSpeaker, u_long uFlags, char *szEventText);
  void Disconnect();


  // Additional BNX Functions
  void ExecuteCommand(char *szCommand, char *szArguments, char *szSpeaker);
  void RandomResponse(char *szName, int type);
  void UserLogin(char *szName, char *szPass);
  void UserLogout(char *szName);
  void LoadDatabase(int type);
  void WriteDatabase(UserList &database, char *szFile, int type);

  // BNX Command Functions
  void CmdBan(char *szArguments, char *szSpeaker);
  void CmdChatter(char *szSpeaker);
  void CmdDesignate(char *szArguments, char *szSpeaker);
  void CmdIgnore(char *szArguments, char *szSpeaker);
  void CmdJoin(char *szChan, char *szSpeaker);
  void CmdKick(char *szArguments, char *szSpeaker);
  void CmdSay(char *szText, char *szSpeaker);
  void CmdShitadd(char *szArguments, char *szSpeaker);
  void CmdShitdel(char *szArguments, char *szSpeaker);
  void CmdShitlist(char *szSpeaker);
  void CmdShutdown(char *szSpeaker);
  void CmdShutup(char *szSpeaker);
  void CmdSplatterKick(char *szArguments, char *szSpeaker);
  void CmdUnban(char *szArguments, char *szSpeaker);
  void CmdUnsquelch(char *szArguments, char *szSpeaker);
  void CmdUseradd(char *szArguments, char *szSpeaker);
  void CmdUserdel(char *szArguments, char *szSpeaker);
  void CmdUserlist(char *szSpeaker);
  void CmdVoteban(char *szArguments, char *szSpeaker);
  void CmdWhere(char *szSpeaker);
  

protected:
  // Protected functions that have to do hwo the bot handles specific data
  // or the opening of files.
  void CreateDefaultUser(User &rUser);
  void CreateDefaultUser(char *szName, User &rUser);
  int MatchUser(char *szUser, char *szDBEntry);
  void ParseCommand(char *szCommandName, char *szArguments, const char *szEventText);
  bool ParseDBEntry(char *szBuffer, User &rBuffer);
  void RemoveWildcards(char *szString);
  void WriteFileHeader(char *szText, ofstream &fileHandle);

  // User lists/databases.
  UserList chanList;
  UserList loggedInList;
  UserList userDB;
  UserList shitList;

  // Other variables.
  char botChannel[MAXTEXTLENGTH];
  bool chatter;
};

#endif
