//
// BOTMAIN.CPP
//
// Global functions and main for the emulated BNX Chatterbox 1.03
// Based off the original GreetBot source by Scott Coleman 3/31/98.
//
// Updated by Lord`Bacca`[vL] of Valhalla Legends
// Released 12/25/2000
//
//
// Please see BNXBOT.CPP and README.TXT for a full description and license
// agreement to this code.
//
//

#include "pch.h"

// our bot instance
BNXBot* BNX = NULL;

// Global Functions to set up the bot
void GetProgramPath(char* szString, char* rBuffer);
void InitializeBot(char* szConfig, char* szPath, BNXBot* bot);


//============================================================================
int __cdecl main(int argc, char** argv) {

  // initialize WinSock
  WSADATA wsadata;
  if (WSAStartup(0x101,&wsadata)) {
    printf("Cannot initialize socket library.\n");
    return 1;
  }
  if (wsadata.wVersion != 0x101) {
    printf("Incorrect socket library version.\n");
    WSACleanup();
    return 1;
  }

  // Declare temporary variables
  char cmdLine[MAXTEXTLENGTH];
  char botPath[MAXTEXTLENGTH];
  char configFile[MAXTEXTLENGTH];

  // Gather information about the current directory
  GetModuleFileName(0,cmdLine,MAXTEXTLENGTH-1);
  GetProgramPath(cmdLine,botPath);
  sprintf(configFile,"%sbot.cfg",botPath);

  // Declare the bot
  BNX = new BNXBot;

  // Gather the basic information the BNX bot needs to connect to battle.net
  InitializeBot(configFile,botPath,BNX);

  // Connect the BNX bot and enter the main message loop.
  // Break from this loop if the bot is shutdown.
  while (1) {
    if (BNX->shutdown || !BNX->Reconnect())
      break;
    BNX->MsgLoop();
    BNX->Disconnect();
  }
  
  // Destroy the bot
  delete BNX;
  // Other shutdown code here

  return 0;
}

void GetProgramPath(char* szString, char *rBuffer) {
// Returns the bot's path from the entire location of the original
// .EXE file.
	strcpy(rBuffer,"");
	int i = strlen(szString);
	int j;
	int k = 0;
	int counter = 0;
	for (j = strlen(szString) - 1; j > 0; j--)
		if (szString[j] == '\\')
			break;

	if (j > 0) {
		strncat(rBuffer,szString,j+1);
		return;
	}
	else {
		strcpy(rBuffer,szString);
	}
}

void InitializeBot(char* szConfig, char* szPath, BNXBot* bot) {
// Read basic configuration information and store them into the bot's
// variables.
	char szUsername[MAXTEXTLENGTH];
	char szPassword[MAXTEXTLENGTH];
	char szServer[MAXTEXTLENGTH];
	char szHome[MAXTEXTLENGTH];
	char szUserList[MAXTEXTLENGTH];
	char szShitList[MAXTEXTLENGTH];
	char szTmpData[MAXTEXTLENGTH];

	GetPrivateProfileString("BNX","username","Guest",szUsername,sizeof(szUsername),szConfig);
	GetPrivateProfileString("BNX","password","Guest",szPassword,sizeof(szPassword),szConfig);
	GetPrivateProfileString("BNX","server","uswest.battle.net",szServer,sizeof(szServer),szConfig);
	GetPrivateProfileString("BNX","home","BNX Bot Testing",szHome,sizeof(szHome),szConfig);
	GetPrivateProfileString("BNX","userlist","access.lst",szUserList,sizeof(szUserList),szConfig);
	GetPrivateProfileString("BNX","shitlist","shit.lst",szShitList,sizeof(szShitList),szConfig);

	// Send the correct configuration file information so the bot can use it.
	bot->SetLogonInfo(szUsername,szPassword,szServer,6112);
	bot->SetHomeChannel(szHome);
	bot->SetConfigFile(szConfig);

	// Make sure that the userlist and shitlist are accessed as absolute
	// paths.
	sprintf(szTmpData,"%s%s",szPath,szUserList);
	bot->SetUserFile(szTmpData);
	sprintf(szTmpData,"%s%s",szPath,szShitList);
	bot->SetShitFile(szTmpData);

	// Load databases
	bot->LoadDatabase(ACCESSLIST);
	bot->LoadDatabase(SHITLIST);
}
